<?xml version="1.0" encoding="UTF-8"?><!-- -*- mode: html; fill-column: 9999; -*- -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
<head>
<title>How to run linphone from a chroot</title>
</head>
<style type="text/css">
pre { border: solid black 1px; }
</style>
<body>
<div><h1>How to run linphone from a chroot</h1>

<p>Last updated: 2023-09-05</p>

<div id="prep"><h2>Preparations and requirements</h2>
<p>This assumes usage of:</p>
<ul>
<li>schroot and having exactly one session of the desired chroot already running</li>
<li>systemd</li>
<li>pulseaudio</li>
<li>xorg</li>
</ul>

<p>A recent enough .deb of linphone-desktop must also be installed (needed for data files).</p>
</div>

<div id="proc"><h2>Procedure</h2>
<ol>
<li><p>Outside chroot as root create bind mounts:</p>

<pre id="outside_root"><![CDATA[( chrootname=unstable-ephem ; normaluser=1000; \
  cd /run/schroot/mount/${chrootname}-*/run/user/ ; \
  mkdir $normaluser ../../dev/{snd,dri} ; \
  mount --rbind /run/user/$normaluser $normaluser ; \
  mount --rbind /dev/snd ../../dev/snd ; \
  mount --rbind /dev/dri ../../dev/dri ; \
  f=$(basename /tmp/dbus-??????????); \
  touch ../../tmp/$f ; \
  mount --bind /tmp/$f ../../tmp/$f ; \
)]]></pre>

<p>With bash and xmlstarlet the above can be run like so:</p>
<pre><![CDATA[source <(xmlstarlet sel -N xhtml=http://www.w3.org/1999/xhtml -t -v "//xhtml:pre[@id='outside_root']/text()" path/to/chroot.xhtml 2>/dev/null | xmlstarlet unesc)]]></pre></li>

<li><p>Outside chroot as normal user copy in config files and data:</p>
<pre id="outside_normal"><![CDATA[( chrootname=unstable-ephem ; username=$(id -un);  \
mkdir -p    $(echo /run/schroot/mount/${chrootname}-*)/tmp/$username/.config/pulse/ ; \
cp       -t $(echo /run/schroot/mount/${chrootname}-*)/tmp/$username/                ~/.config/pulse/cookie ; \
mkdir -p    $(echo /run/schroot/mount/${chrootname}-*)/tmp/$username/.{config,local/share} ; \
cp -R -a -t $(echo /run/schroot/mount/${chrootname}-*)/tmp/$username/.config         ~/.config/linphone ; \
cp -R -a -t $(echo /run/schroot/mount/${chrootname}-*)/tmp/$username/.local/share    ~/.local/share/linphone ; \
cp -f    -t $(echo /run/schroot/mount/${chrootname}-*)/tmp/$username/                ~/.Xauthority ~/.linphonerc ; \
)
]]></pre>

<p>With bash and xmlstarlet the above can be run like so:</p>
<pre><![CDATA[source <(xmlstarlet sel -N xhtml=http://www.w3.org/1999/xhtml -t -v "//xhtml:pre[@id='outside_normal']/text()" path/to/chroot.xhtml 2>/dev/null | xmlstarlet unesc)]]></pre></li>

<li><p>Inside chroot as normal user run the desired linphone variant:</p>
<pre id="inside_ld"># linphone-desktop
( export HOME=/tmp/$(id -un) XDG_RUNTIME_DIR=/run/user/$(id -u) DISPLAY=:0 GDK_BACKEND=x11 QT_QPA_PLATFORMTHEME=gtk2 ; build/linphone-app/linphone )
</pre>

<pre id="inside_lc"># linphonec (needs package linphone-cli installed)
( export HOME=/tmp/$(id -un) XDG_RUNTIME_DIR=/run/user/$(id -u) DISPLAY=:0 GDK_BACKEND=x11 QT_QPA_PLATFORMTHEME=gtk2 ; linphonec -c $HOME/.config/linphone/linphonerc -V )
</pre>
</li>
</ol>
</div>
</div>
</body>
</html>
